
#include <stdio.h>

#define PREFIXCHAR '"'
typedef struct { char c; char* transl; } COOKIE;

COOKIE theCookies[] =  {
  {'a',"&auml;"}, {'o',"&ouml;"}, {'u',"&uuml;"},
  {'A',"&Auml;"}, {'U',"&Ouml;"}, {'U',"&Uuml;"},
  {'s',"&szlig;"},
  {'<',"&lt;"},{'>',"&gt;"},{'&',"&amp"},
  {'"',"\""}
};

int theCookSem=0;
int cooking_lock()  {  return theCookSem++; }
int cooking_unlock(){  return theCookSem--; }

int getcc(FILE*f) {
  static char holdb[2]={'\0','\0'};
  static char *transl=holdb;
  int c;
  int idx;
  if(*transl) return *transl++;
  if((c=getc(f))!=PREFIXCHAR || theCookSem>0) return c;
  if((c=getc(f))==EOF) return PREFIXCHAR;
  for(idx=0;idx<sizeof(theCookies)/sizeof(COOKIE);++idx)
  if(theCookies[idx].c==c) {
    transl=theCookies[idx].transl;
    return *transl++;
  }
  holdb[0]=c; transl=holdb;
  return PREFIXCHAR;
}

/*
int main() {
  char c;
  while((c=getcc(stdin))!=EOF) putchar(c);
}
*/
