#include "sgml2.h"
#include <strings.h>

#define output(s) fputs((s),stdout)

CHARCONV * theCharconvs=NULL;

char * cconvfind(CHARCONV*cv,char*s) {
  if(!cv) return NULL;
  if(!strcmp(cv->key,s)) return cv->data;
  return cconvfind(cv->next,s);
}

#define BUFLEN 256
static char b[BUFLEN];
static char *d=b;
static int state=0;

flusho() {
  state=0;
  *d=0;
  output(b);
  d=b;
}

int oc(char c) {
  char *cv;
  if(d<b+BUFLEN-1) {
    if(c==CHARCONVCHAR && state==0) {
      flusho();
      state=1;
    } else if(state==1 && c==CHARCONVEND) {
      *d=0;
      if(cv=cconvfind(theCharconvs,b+1)) {
	d=b; 
	output(cv);
      }
      else {
	*d++=c;
	flusho();
      }
      state=0;
    } else {
      *d++=c;
    }
  } else { 
    flusho(); 
    oc(c);
  }
}

int o(char *s) {
  while(*s) {
    oc(*s++);
  }
  return 1;
}
