
# line 2 "sgml2.y"
#include "sgml2.h"

/* static yyparse(); */
int yyparse();

MARK * theMarks;

int bidx;
char buffer[200];
#define CLEARBUFFER  {buffer[bidx=0]=0;}
#define APPBUFFER(a) {if(bidx>=200) {fputs("Buffer overflow",stderr);\
		      CLOSEBUFFER;fputs(buffer,stderr);YYABORT;} \
                      buffer[bidx++]=(a);}
#define CLOSEBUFFER  {buffer[bidx]=0;}
#define SETBUFFER(a) {CLEARBUFFER;APPBUFFER(a);}

char mrkbuf[100];

#ifdef __cplusplus
#  include <stdio.h>
#  include <yacc.h>
#endif	/* __cplusplus */ 
# define ALNUM 257
# define WS 258
# define MARKBEG 259
# define MARKEND 260
# define EXCLAIM 261
# define DASH 262
# define ENDMARK 263
# define ASSIGN 264
# define QUOTE 265
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif

/* __YYSCLASS defines the scoping/storage class for global objects
 * that are NOT renamed by the -p option.  By default these names
 * are going to be 'static' so that multi-definition errors
 * will not occur with multiple parsers.
 * If you want (unsupported) access to internal names you need
 * to define this to be null so it implies 'extern' scope.
 * This should not be used in conjunction with -p.
 */
#ifndef __YYSCLASS
# define __YYSCLASS static
#endif
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval;
__YYSCLASS YYSTYPE yyval;
typedef int yytabelem;
# define YYERRCODE 256

# line 75 "sgml2.y"


static int theLine,theCol;

int yylex() {
  yylval=getcc(stdin);
  theCol = yylval=='\n' ? ++theLine,1 : theCol+1;
  switch(yylval) {
  case EOF: return 0;
  case '<': return MARKBEG;
  case '>': return MARKEND;
  case '/': return ENDMARK;
  case '=': return ASSIGN;
  case '"': return QUOTE;
  case '!': return EXCLAIM;
  case '-': return DASH;
  default: if(yylval>32) return ALNUM; else return WS;
  }
}

static yyerror(char * s) {
  fprintf(stderr,":%d:%d: %s\n",theLine,theCol,s);
}

int sgmlparse() {
  theLine=theCol=1;
  while(!feof(stdin)) {
    theMarks=NULL;
    if(yyparse()) exit(1);
    flusho();
    while(theMarks) mrkfree(mrkspop(&theMarks));
  }
 return 0;
}
__YYSCLASS yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 46
# define YYLAST 83
__YYSCLASS yytabelem yyact[]={

    48,    47,    51,    52,    11,    12,     9,    10,    45,     5,
     4,     8,    25,    11,    12,     9,    10,     6,     5,     4,
    42,    38,    11,    12,     9,    10,     6,    14,    33,    16,
    22,    18,    17,    25,    35,    29,    25,     7,    24,     2,
    19,    -1,    50,    46,    44,    43,    41,    39,    37,    34,
    32,    31,    28,    23,    20,    21,    15,    27,    13,     3,
     1,     0,    26,     0,     0,     0,     0,    30,     0,     0,
     0,    36,     0,     0,     0,     0,     0,    40,     0,     0,
     0,     0,    49 };
__YYSCLASS yytabelem yypact[]={

 -3000,  -248, -3000, -3000, -3000, -3000, -3000, -3000,  -234, -3000,
 -3000, -3000, -3000,  -228,  -231, -3000, -3000, -3000,  -232, -3000,
  -221, -3000, -3000, -3000,  -222, -3000, -3000,  -239, -3000, -3000,
 -3000,  -230,  -224, -3000, -3000, -3000,  -222,  -243,  -245, -3000,
  -222, -3000, -3000, -3000,  -257, -3000, -3000, -3000, -3000, -3000,
 -3000, -3000, -3000 };
__YYSCLASS yytabelem yypgo[]={

     0,    60,    39,    59,    58,    57,    56,    40,    55,    54,
    53,    52,    51,    38,    50,    49,    48,    47,    46,    45,
    44,    43,    37,    42,    41 };
__YYSCLASS yytabelem yyr1[]={

     0,     1,     1,     1,     3,     4,     6,     4,     8,     4,
     9,    11,     7,    10,    12,    12,    16,    15,    17,    17,
    13,    13,    19,    18,    20,    20,     5,     5,    21,    21,
    21,    21,     2,     2,     2,     2,    22,    22,    22,    22,
    23,    23,    24,    24,    14,    14 };
__YYSCLASS yytabelem yyr2[]={

     0,     0,     5,     4,     6,     8,     1,     4,     1,     6,
     1,     1,     9,     3,     0,     6,     1,     9,     2,     2,
     3,     5,     1,     9,     0,     5,     0,     4,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     0,     2,     2,     4 };
__YYSCLASS yytabelem yychk[]={

 -3000,    -1,    -2,    -3,   258,   257,   265,   -22,   259,   263,
   264,   261,   262,    -4,   261,    -6,   263,   260,   262,    -7,
    -9,    -8,   262,   -10,   -13,   257,    -7,    -5,   -11,   257,
    -2,   -12,   -14,   258,   -15,   258,   -13,   -16,   264,   -17,
   -13,   -18,   265,   -19,   -20,   265,   -21,   258,   257,   -22,
   -23,   259,   260 };
__YYSCLASS yytabelem yydef[]={

     1,    -2,     2,     3,    32,    33,    34,    35,     6,    36,
    37,    38,    39,     0,     0,    10,     8,     4,     0,     7,
     0,    10,    26,    11,    13,    20,     9,     5,    14,    21,
    27,    12,     0,    44,    15,    45,    16,     0,     0,    17,
    18,    19,    22,    24,     0,    23,    25,    28,    29,    30,
    31,    40,    41 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

__YYSCLASS yytoktype yytoks[] =
{
	"ALNUM",	257,
	"WS",	258,
	"MARKBEG",	259,
	"MARKEND",	260,
	"EXCLAIM",	261,
	"DASH",	262,
	"ENDMARK",	263,
	"ASSIGN",	264,
	"QUOTE",	265,
	"-unknown-",	-1	/* ends search */
};

__YYSCLASS char * yyreds[] =
{
	"-no such reduction-",
	"text : /* empty */",
	"text : text character",
	"text : text markup",
	"markup : MARKBEG marking MARKEND",
	"marking : EXCLAIM DASH DASH comment",
	"marking : /* empty */",
	"marking : markingrest",
	"marking : ENDMARK",
	"marking : ENDMARK markingrest",
	"markingrest : /* empty */",
	"markingrest : mark",
	"markingrest : mark options",
	"mark : word",
	"options : /* empty */",
	"options : options gap option",
	"option : word",
	"option : word ASSIGN optionvalue",
	"optionvalue : word",
	"optionvalue : string",
	"word : ALNUM",
	"word : word ALNUM",
	"string : QUOTE",
	"string : QUOTE stringchars QUOTE",
	"stringchars : /* empty */",
	"stringchars : stringchars stringchar",
	"comment : /* empty */",
	"comment : comment character",
	"stringchar : WS",
	"stringchar : ALNUM",
	"stringchar : specialchar",
	"stringchar : markchar",
	"character : WS",
	"character : ALNUM",
	"character : QUOTE",
	"character : specialchar",
	"specialchar : ENDMARK",
	"specialchar : ASSIGN",
	"specialchar : EXCLAIM",
	"specialchar : DASH",
	"markchar : MARKBEG",
	"markchar : MARKEND",
	"cgap : /* empty */",
	"cgap : gap",
	"gap : WS",
	"gap : gap WS",
};
#endif /* YYDEBUG */
#define YYFLAG  (-3000)
/* @(#) $Revision: 70.7 $ */    

/*
** Skeleton parser driver for yacc output
*/

#if defined(NLS) && !defined(NL_SETN)
#include <msgbuf.h>
#endif

#ifndef nl_msg
#define nl_msg(i,s) (s)
#endif

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab

#ifndef __RUNTIME_YYMAXDEPTH
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#else
#define YYACCEPT	{free_stacks(); return(0);}
#define YYABORT		{free_stacks(); return(1);}
#endif

#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( (nl_msg(30001,"syntax error - cannot backup")) );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
/* define for YYFLAG now generated by yacc program. */
/*#define YYFLAG		(FLAGVAL)*/

/*
** global variables used by the parser
*/
# ifndef __RUNTIME_YYMAXDEPTH
__YYSCLASS YYSTYPE yyv[ YYMAXDEPTH ];	/* value stack */
__YYSCLASS int yys[ YYMAXDEPTH ];		/* state stack */
# else
__YYSCLASS YYSTYPE *yyv;			/* pointer to malloc'ed value stack */
__YYSCLASS int *yys;			/* pointer to malloc'ed stack stack */

#if defined(__STDC__) || defined (__cplusplus)
#include <stdlib.h>
#else
	extern char *malloc();
	extern char *realloc();
	extern void free();
#endif /* __STDC__ or __cplusplus */


static int allocate_stacks(); 
static void free_stacks();
# ifndef YYINCREMENT
# define YYINCREMENT (YYMAXDEPTH/2) + 10
# endif
# endif	/* __RUNTIME_YYMAXDEPTH */
long  yymaxdepth = YYMAXDEPTH;

__YYSCLASS YYSTYPE *yypv;			/* top of value stack */
__YYSCLASS int *yyps;			/* top of state stack */

__YYSCLASS int yystate;			/* current state */
__YYSCLASS int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
__YYSCLASS int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
# ifdef __RUNTIME_YYMAXDEPTH
	if (allocate_stacks()) YYABORT;
# endif
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
# ifndef __RUNTIME_YYMAXDEPTH
			yyerror( (nl_msg(30002,"yacc stack overflow")) );
			YYABORT;
# else
			/* save old stack bases to recalculate pointers */
			YYSTYPE * yyv_old = yyv;
			int * yys_old = yys;
			yymaxdepth += YYINCREMENT;
			yys = (int *) realloc(yys, yymaxdepth * sizeof(int));
			yyv = (YYSTYPE *) realloc(yyv, yymaxdepth * sizeof(YYSTYPE));
			if (yys==0 || yyv==0) {
			    yyerror( (nl_msg(30002,"yacc stack overflow")) );
			    YYABORT;
			    }
			/* Reset pointers into stack */
			yy_ps = (yy_ps - yys_old) + yys;
			yyps = (yyps - yys_old) + yys;
			yy_pv = (yy_pv - yyv_old) + yyv;
			yypv = (yypv - yyv_old) + yyv;
# endif

		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( (nl_msg(30003,"syntax error")) );
				yynerrs++;
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 2:
# line 28 "sgml2.y"
{SETBUFFER(yypvt[-0]);CLOSEBUFFER;o(buffer);} break;
case 6:
# line 35 "sgml2.y"
{strcpy(mrkbuf,STRBEG);} break;
case 8:
# line 36 "sgml2.y"
{strcpy(mrkbuf,STREND);} break;
case 10:
# line 38 "sgml2.y"
{cooking_lock();} break;
case 11:
# line 39 "sgml2.y"
{mrkspush(&theMarks,mrknew(strcat(mrkbuf,buffer)));} break;
case 12:
# line 41 "sgml2.y"
{cooking_unlock();mrkprint(theMarks);} break;
case 13:
# line 43 "sgml2.y"
{CLOSEBUFFER;} break;
case 16:
# line 49 "sgml2.y"
{CLOSEBUFFER;mrkaddopt(theMarks,optnew(buffer,NULL));} break;
case 17:
# line 51 "sgml2.y"
{CLOSEBUFFER;optset(theMarks->options,buffer);} break;
case 20:
# line 55 "sgml2.y"
{SETBUFFER(yypvt[-0]);} break;
case 21:
# line 56 "sgml2.y"
{APPBUFFER(yypvt[-0]);} break;
case 22:
# line 59 "sgml2.y"
{CLEARBUFFER;} break;
case 23:
# line 59 "sgml2.y"
{CLOSEBUFFER;} break;
case 25:
# line 61 "sgml2.y"
{APPBUFFER(yypvt[-0]);} break;
	}
	goto yystack;		/* reset registers in driver code */
}

# ifdef __RUNTIME_YYMAXDEPTH

static int allocate_stacks() {
	/* allocate the yys and yyv stacks */
	yys = (int *) malloc(yymaxdepth * sizeof(int));
	yyv = (YYSTYPE *) malloc(yymaxdepth * sizeof(YYSTYPE));

	if (yys==0 || yyv==0) {
	   yyerror( (nl_msg(30004,"unable to allocate space for yacc stacks")) );
	   return(1);
	   }
	else return(0);

}


static void free_stacks() {
	if (yys!=0) free((char *) yys);
	if (yyv!=0) free((char *) yyv);
}

# endif  /* defined(__RUNTIME_YYMAXDEPTH) */

